<template>
  <div class="maps">
    <div class="w-full mb-2">
      <gmap-autocomplete v-model="address" class="introInput" :options="autoCompleteOptions" @place_changed="setPlace">
        <template v-slot:input="slotProps" childRefName="myinput">
          <input
            ref="input"
            class="bg-white input-search border border-gray-300 py-2 px-4 rounded-lg block w-full focus:outline-none appearance-none leading-normal"
            type="myinput"
            placeholder="Masukkan lokasi anda disini..."
            @listeners="slotProps.listeners"
            @attrs="slotProps.attrs"
          />
        </template>
      </gmap-autocomplete>
    </div>
    <gmap-map ref="gmaps" :center="center" :map-type-id="mapTypeId" :zoom="12">
      <gmap-marker
        :position="center"
        :draggable="true"
        :clickable="true"
        @dragend="dragendHandler"
        @click="toggleInfoWindow"
      />
      <!-- <gmap-info-window
        :options="infoOptions"
        :position="center"
        :opened="infoWindowOpen"
        @closeclick="infoWindowOpen = false"
      >
        Ini isinya lohh: {{ address }}
      </gmap-info-window> -->
    </gmap-map>
  </div>
</template>

<script>
import { mapState } from 'vuex';
export default {
  data() {
    return {
      mapTypeId: 'terrain',
      // infoWindowOpen: false,
      // infoOptions: {
      //   //optional: offset infowindow so it visually sits nicely on top of our marker
      //   pixelOffset: {
      //     width: 0,
      //     height: -35,
      //   },
      // },
      autoCompleteOptions: {
        componentRestrictions: {
          country: ['id'],
        },
      },
    };
  },
  computed: {
    ...mapState({
      clientLocation: state => state.clientInfo.location,
    }),
    address: {
      get() {
        return this.$store.state.form.address;
      },
      set(val) {
        return this.$store.commit('form/SET_ADDRESS', val);
      },
    },
    lat: {
      get() {
        return this.$store.state.form.lat;
      },
      set(val) {
        return this.$store.commit('form/SET_LAT', val);
      },
    },
    lng: {
      get() {
        return this.$store.state.form.lng;
      },
      set(val) {
        return this.$store.commit('form/SET_LNG', val);
      },
    },
    center() {
      return {
        lat: this.lat,
        lng: this.lng,
      };
    },
  },
  methods: {
    // toggleInfoWindow() {
    //   this.infoWindowOpen = !this.infoWindowOpen;
    // },
    dragendHandler(evt) {
      this.lat = evt.latLng.lat();
      this.lng = evt.latLng.lng();
    },
    setPlace(val) {
      const resultJson = val.geometry.location.toJSON(),
        lat = resultJson.lat,
        lng = resultJson.lng;
      this.lat = lat;
      this.lng = lng;
      this.address = val.formatted_address;
    },
  },
};
</script>
<style lang="scss" scoped>
.maps {
  width: 800px;
  height: 450px;
}
.input-search {
  color: $black-alt;
}

.vue-map-container {
  height: 100%;
  position: relative;
}

.vue-map-container .vue-map {
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;
  position: absolute;
}
.vue-map-hidden {
  display: none;
}
</style>
